
MACRO(METNO_PVERSION VERSION)
  STRING(REGEX REPLACE "^([0-9]+)\\.[0-9]+(\\.[0-9]+(~(rc|a|b)[0-9]+)?)?$" \\1 PVERSION_MAJOR "${VERSION}")
  STRING(REGEX REPLACE "^[0-9]+\\.([0-9]+)(\\.[0-9]+(~(rc|a|b)[0-9]+)?)?$" \\1 PVERSION_MINOR "${VERSION}")

  IF("${VERSION}" MATCHES "^[0-9]+\\.[0-9]+\\.[0-9]+(~(rc|a|b)[0-9]+)?$")
    STRING(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]+)(~(rc|a|b)[0-9]+)?$" \\1 PVERSION_PATCH "${VERSION}")
  ELSE()
    SET(PVERSION_PATCH 0)
  ENDIF()

  SET(PVERSION_MAJOR_DOT_MINOR "${PVERSION_MAJOR}.${PVERSION_MINOR}")
  MATH(EXPR PVERSION_NUMBER_MAJOR_MINOR "1000*${PVERSION_MAJOR}+${PVERSION_MINOR}")
  MATH(EXPR PVERSION_NUMBER_MAJOR_MINOR_PATCH "1000000*${PVERSION_MAJOR}+1000*${PVERSION_MINOR}+${PVERSION_PATCH}")

  SET(PROGRAM_SUFFIX "" CACHE STRING "program suffix")
  SET(PVERSION "${PVERSION_MAJOR_DOT_MINOR}${PROGRAM_SUFFIX}")
  SET(PVERSION_FULL "${VERSION}${PROGRAM_SUFFIX}")
ENDMACRO(METNO_PVERSION)
